#------------------------------------------------------------
# Swaptotal.py
# Flip the symmetry of the whole figure with one button push, for all frames
# Copyright (c) 2005 David G. Drumright (ockham)
#------------------------------------------------------------

import poser
scene = poser.Scene()

#-----------------------------------------------------------------------------
# In currently selected figure, swap right and left.
#-----------------------------------------------------------------------------
try:
  TheFigure = scene.CurrentFigure()
except:
  exit

#-----------------------------------------------------------------------------
# Swapping on all frames requires keyframing all first.
for F in range(scene.NumFrames()):
    scene.SetFrame(F)
    for A in TheFigure.Actors():
        A.AddKeyFrame(F)

# Now do the swap
for F in range(scene.NumFrames()):
    scene.SetFrame(F)
    TheFigure.SwapTop()
    TheFigure.SwapBottom()
    MidlineList = ["Neck","Head","Chest","Abdomen","Hip","Left Eye","Right Eye"]
    for Name in MidlineList:
        try:
            OneActor = TheFigure.Actor(Name)
        except:
            pass
        try:
            TwistParm = OneActor.ParameterByCode(poser.kParmCodeYROT)
            TwistParm.SetValue(-TwistParm.Value())
        except:
            pass
        try:
            SideParm = OneActor.ParameterByCode(poser.kParmCodeZROT)
            SideParm.SetValue(-SideParm.Value())
        except:
            pass

